ParameterImpl (Media Authoring with Java API)
Date: 2016-02-05

tv.amwa.maj.model.impl

## Class ParameterImpl

- java.lang.Object
- - tv.amwa.maj.model.impl.InterchangeObjectImpl
  - - tv.amwa.maj.model.impl.ParameterImpl

- All Implemented Interfaces:
    Serializable, Cloneable, MediaEntity, MetadataObject, InterchangeObject, Parameter
  Direct Known Subclasses:
    ConstantValueImpl, VaryingValueImpl

      @MediaClass(uuid1=218169601,
                  uuid2=257,
                  uuid3=15360,
                  uuid4={6,14,43,52,2,6,1,1},
                  definedName="Parameter",
                  description="The Parameter class specifies an effect control value.",
                  symbol="Parameter",
                  isConcrete=false)
      public class ParameterImpl
      extends InterchangeObjectImpl
      implements Parameter, Serializable, Cloneable

  Implements an effect control value. Effect control values are parameters to operations specified by operation groups.

  See Also:
    `TypeDefinitions.ParameterStrongReference`, `TypeDefinitions.ParameterStrongReferenceVector`, Serialized Form

- - ### Field Summary

    - ### Fields inherited from class tv.amwa.maj.model.impl.InterchangeObjectImpl

      `ObjectClassPropertyID`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ParameterImpl()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Parameter` | `clone()` Create a cloned copy of this interchange object.
    `String` | `getComment()`
    `ParameterDefinition` | `getParameterDefinition()` Returns the parameter definition of this operation parameter.
    `AUID` | `getParameterDefinitionReference()` Returns the unique identifier for the parameter definition of this parameter.
    `String` | `getParameterDefinitionReferenceString()`
    `TypeDefinition` | `getTypeDefinition()` Returns the type definition of the data value of this parameter.
    `static AUID` | `initializeParameterDefinitionReference()`
    `void` | `setParameterDefinition(ParameterDefinition parameterDefinition)`
    `void` | `setParameterDefinitionReference(AUID parameterDefinitionReference)`
    `void` | `setParameterDefinitionReferenceFromStream(AUID parameterDefinitionReference)`
    `void` | `setParameterDefinitionReferenceString(String parameterDefinitionReference)`

    - ### Methods inherited from class tv.amwa.maj.model.impl.InterchangeObjectImpl

      `addApplicationPlugin, appendXMLChildren, clearApplicationPlugins, containsApplicationPlugin, containsApplicationPlugin, countApplicationPlugins, deepEquals, disableGenerationTracking, enableGenerationTracking, equals, getApplicationPlugins, getGeneration, getLinkedGenerationID, getLinkedGenerationIDString, getObjectClass, getPersistentID, getPersistentIndex, hashCode, isGenerationTracked, removeApplicationPlugin, removeApplicationPlugin, setLinkedGenerationID, setLinkedGenerationIDString, setObjectClass, setPersistentID, setPersistentIndex, toString`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface tv.amwa.maj.model.InterchangeObject

      `addApplicationPlugin, clearApplicationPlugins, containsApplicationPlugin, containsApplicationPlugin, countApplicationPlugins, deepEquals, disableGenerationTracking, enableGenerationTracking, equals, getApplicationPlugins, getGeneration, getLinkedGenerationID, getObjectClass, isGenerationTracked, removeApplicationPlugin, removeApplicationPlugin, setLinkedGenerationID, setObjectClass, toString`

    - ### Methods inherited from interface tv.amwa.maj.industry.MediaEntity

      `getPersistentID, setPersistentIndex`

- - ### Constructor Detail

    - #### ParameterImpl

          public ParameterImpl()

  - ### Method Detail

    - #### getParameterDefinition

          public ParameterDefinition getParameterDefinition()

      Description copied from interface: `Parameter`

      Returns the parameter definition of this operation parameter.

      Specified by:
        `getParameterDefinition` in interface `Parameter`
      Returns:
        Parameter definition of this operation parameter.
      See Also:
        `Parameter.getParameterDefinitionReference()`, `Warehouse.lookup(Class, String)`

    - #### setParameterDefinitionReference

          public void setParameterDefinitionReference(AUID parameterDefinitionReference)
                                               throws NullPointerException,
                                                      ParameterNotFoundException

      Throws:
        `NullPointerException`
        `ParameterNotFoundException`

    - #### setParameterDefinitionReferenceFromStream

          @MediaPropertySetter(value="ParameterDefinitionReference")
          public void setParameterDefinitionReferenceFromStream(AUID parameterDefinitionReference)
                                                                                                                    throws NullPointerException

      Throws:
        `NullPointerException`

    - #### setParameterDefinition

          public void setParameterDefinition(ParameterDefinition parameterDefinition)
                                      throws NullPointerException

      Throws:
        `NullPointerException`

    - #### initializeParameterDefinitionReference

          public static final AUID initializeParameterDefinitionReference()

    - #### getParameterDefinitionReference

          @MediaProperty(uuid1=100729092,
                         uuid2=260,
                         uuid3=0,
                         uuid4={6,14,43,52,1,1,1,2},
                         definedName="ParameterDefinitionReference",
                         aliases="Definition",
                         typeName="AUID",
                         optional=false,
                         uniqueIdentifier=false,
                         pid=19457,
                         symbol="ParameterDefinitionReference")
          public AUID getParameterDefinitionReference()

      Returns the unique identifier for the parameter definition of this parameter.

      Specified by:
        `getParameterDefinitionReference` in interface `Parameter`
      Returns:
        Unique identifier for the parameter definition of this parameter.
      See Also:
        `Parameter.getParameterDefinition()`, `DefinitionObject.getAUID()`, `Warehouse.lookup(Class, AUID)`

    - #### getTypeDefinition

          public TypeDefinition getTypeDefinition()

      Description copied from interface: `Parameter`

      Returns the type definition of the data value of this parameter. It is often an integer or rational value and the value may vary with time.

      Note that the type definition is stored in the base class because it should be the same for all control points inside of a varying value.

      Specified by:
        `getTypeDefinition` in interface `Parameter`
      Returns:
        Type definition of the data value inside the parameter.
      See Also:
        `Parameter.getParameterDefinition()`, `ParameterDefinition.getParameterType()`

    - #### clone

          public Parameter clone()

      Description copied from interface: `InterchangeObject`

      Create a cloned copy of this interchange object.

      Specified by:
        `clone` in interface `MediaEntity`
      Specified by:
        `clone` in interface `InterchangeObject`
      Specified by:
        `clone` in interface `Parameter`
      Overrides:
        `clone` in class `InterchangeObjectImpl`
      Returns:
        Cloned copy of this interchange object.

    - #### getComment

          public String getComment()

      Overrides:
        `getComment` in class `InterchangeObjectImpl`

    - #### getParameterDefinitionReferenceString

          public String getParameterDefinitionReferenceString()

    - #### setParameterDefinitionReferenceString

          public void setParameterDefinitionReferenceString(String parameterDefinitionReference)

(c)2007-2016 Richard Cartwright, all rights reserved. Licensed under Apache 2 license and subject to the AMWA IPR policy.